function [uh, xh, yh, Kx, Kr] = PR_bezomezeni(Tp, R, Q, ref, N, Ad,Bd,Cd,Dd)

Ns = size(Ad,1);

%predikce vystupu
V = [];
for i=0:1:Tp-1
   V=[V;Cd*Ad^i];
end

% matice S

S = zeros(Tp,Tp);
for j=1:Tp
   for i=1:Tp
      if j==i
         S(i,j)=Dd;
      elseif j==i-1
         S(i,j)=Cd*Bd;
      elseif j<i-1
         S(i,j)=Cd*Ad^(i-j-1)*Bd;
      end
   end
end

       
	% matice analytickeho regulatoru

	G = inv(S'*Q*S+R)*S'*Q;
	F = G*V;
	Kx = F(1,:);
	Kr = sum(G(1,:));

	% historie

	uh = zeros(1,N);
	xh = zeros(Ns,N);
	yh = zeros(1,N);

	x = zeros(Ns,1);

	%simulace
	start = Ns+1;
	for t=start:N
   	up = -Kx*x + Kr*ref(t);
	   y = Cd*x + Dd*up;
   
   	xh(:,t) = x;
	   yh(t) = y;
   	uh(t) = up;
   
	   x = Ad*x + Bd*up;
   end